<script src="./Script.js"></script>

<template>
  <div class="row" v-if="attributes && attributes.length > 0">
    <div
      class="form-group m-form__group m--padding-5 nt-width-296"
      v-for="(attribute, index) in attributes"
      :key="index"
      :class="{ 'has-danger': errors.has(scope + '.' + attribute.attribute_code) || server_errors[attribute.attribute_code]} "
    >
      <label
        v-if="attribute.attribute_code !== 'charge_person' && attribute.attribute_code !== 'user_id' && attribute.attribute_code !== 'created_at'"
        :for="attribute.attribute_code"
        class="form-control-label s--label nt-label"
      >
        {{ attribute.attribute_code == 'contact_user' ? 'Người liên hệ khi mua' : attribute.attribute_name }}
        <span
          class="m--font-danger"
          v-if="attribute.is_required"
        >*</span>
      </label>

      <label
        v-else-if="attribute.attribute_code === 'charge_person' && extend"
        for="assigners"
        class="form-control-label s--label nt-label"
      >Người phụ trách</label>

      <label
        v-else-if="attribute.attribute_code === 'user_id' && is_edit && extend"
        for="assigners"
        class="form-control-label s--label nt-label"
      >Người tạo</label>

      <label
        v-else-if="attribute.attribute_code === 'created_at' && is_edit && extend"
        for="assigners"
        class="form-control-label s--label nt-label"
      >Ngày tạo</label>

      <template v-if="attribute.data_type">
        <template
          v-if="attribute.data_type.id == isText && (attribute.attribute_code == 'customer_code' || attribute.attribute_code == 'customer_name' || attribute.attribute_code == 'order_code')"
        >
          <s-input-text
            class="nt-disabled-input"
            disabled="disabled"
            :data-vv-scope="scope"
            v-model="attribute.attribute_value"
            v-validate="{ required: attribute.is_required ? true : false, max: 250 }"
            :id="attribute.attribute_code"
            :name="attribute.attribute_code"
            @keyup="changeDataInputType($event, attribute.attribute_code)"
          ></s-input-text>
        </template>
        <template
          v-if="attribute.data_type.id == isText && attribute.attribute_code != 'customer_code' && attribute.attribute_code != 'customer_name' && attribute.attribute_code != 'order_code'"
        >
          <s-input-text
            :data-vv-scope="scope"
            v-model="attribute.attribute_value"
            v-validate="{ required: attribute.is_required ? true : false, max: 250 }"
            :id="attribute.attribute_code"
            :name="attribute.attribute_code"
            @keyup="changeDataInputType($event, attribute.attribute_code)"
          ></s-input-text>
        </template>

        <template
          v-if="(attribute.data_type.id == isDate || attribute.attribute_code == 'order_date') && attribute.attribute_code != 'created_at'"
        >
          <s-input-date
            :data-vv-scope="scope"
            v-model="attribute.attribute_value"
            v-validate="{ required: attribute.is_required ? true : false }"
            :id="attribute.attribute_code"
            :name="attribute.attribute_code"
            @keyup="changeDataInputType($event, attribute.attribute_code)"
          ></s-input-date>
        </template>

        <template
          v-if="attribute.data_type.id == isDate && attribute.attribute_code == 'created_at' && is_edit && extend"
        >
          <s-input-text
            class="nt-disabled-input"
            disabled="disabled"
            :data-vv-scope="scope"
            v-model="deal.created_at"
            :id="attribute.attribute_code"
            :name="attribute.attribute_code"
          ></s-input-text>
        </template>

        <template
          v-if="attribute.data_type.id == isDateTime && attribute.attribute_code != 'order_date' && attribute.attribute_code != 'created_at'"
        >
          <s-input-date-time
            :data-vv-scope="scope"
            v-model="attribute.attribute_value"
            v-validate="{ required: attribute.is_required ? true : false }"
            :id="attribute.attribute_code"
            :name="attribute.attribute_code"
            @keyup="changeDataInputType($event, attribute.attribute_code)"
          ></s-input-date-time>
        </template>

        <template v-if="attribute.data_type.id == isPhone">
          <s-input-phone
            :data-vv-scope="scope"
            v-model="attribute.attribute_value"
            v-validate="{ required: attribute.is_required ? true : false, regex: helpers.regexPhone() }"
            :id="attribute.attribute_code"
            :name="attribute.attribute_code"
            @keyup="changeDataInputType($event, attribute.attribute_code)"
          ></s-input-phone>
        </template>

        <template v-if="attribute.data_type.id == isEmail">
          <s-input-email
            :data-vv-scope="scope"
            v-model="attribute.attribute_value"
            v-validate="{ required: attribute.is_required ? true : false, regex: helpers.regexEmail(), max: 250 }"
            :id="attribute.attribute_code"
            :name="attribute.attribute_code"
            @keyup="changeDataInputType($event, attribute.attribute_code)"
          ></s-input-email>
        </template>

        <template v-if="attribute.data_type.id == isNumber">
          <s-input-number-custom
            :data-vv-scope="scope"
            v-model="attribute.attribute_value"
            v-validate="{ required: attribute.is_required ? true : false }"
            :id="attribute.attribute_code"
            :name="attribute.attribute_code"
            @keyup="changeDataInputType($event, attribute.attribute_code)"
          ></s-input-number-custom>
        </template>

        <template v-if="attribute.data_type.id == isPrice">
          <!--@Todo Sau này làm component input price theo vnđ-->
          <s-input-number-custom
            :data-vv-scope="scope"
            v-model="attribute.attribute_value"
            :is_decimal="false"
            v-validate="{ required: attribute.is_required ? true : false }"
            :id="attribute.attribute_code"
            :name="attribute.attribute_code"
            @keyup="changeDataInputType($event, attribute.attribute_code)"
          ></s-input-number-custom>
          <!--<s-input-price :data-vv-scope="scope" v-model="attribute.attribute_value" v-validate="{ required: attribute.is_required ? true : false }" :id="attribute.attribute_code" :name="attribute.attribute_code"></s-input-price>-->
        </template>

        <template
          v-if="attribute.data_type.id == isSelect && attribute.attribute_code == 'order_payment_status'"
        >
          <s-select
            class="nt-disabled-input"
            disabled="disabled"
            :data-vv-scope="scope"
            v-model="attribute.attribute_value"
            v-validate="{ required: attribute.is_required ? true : false }"
            :id="attribute.attribute_code"
            :name="attribute.attribute_code"
            :data="attribute.attribute_options"
            :label="'option_value'"
            @change="changeDataInputType($event, attribute.attribute_code)"
          ></s-select>
        </template>

        <template
          v-if="attribute.data_type.id == isSelect && attribute.attribute_code == 'user_id' && is_edit && extend"
        >
          <s-input-text
            class="nt-disabled-input"
            disabled="disabled"
            :data-vv-scope="scope"
            :value="getUsersByValue()"
            id="created_user"
            name="created_user"
          ></s-input-text>
        </template>

        <template
          v-if="attribute.data_type.id == isSelect && attribute.attribute_code != 'order_payment_status' && attribute.attribute_code != 'user_id'"
        >
          <s-select
            :data-vv-scope="scope"
            v-model="attribute.attribute_value"
            v-validate="{ required: attribute.is_required ? true : false }"
            :id="attribute.attribute_code"
            :name="attribute.attribute_code"
            :data="attribute.attribute_options"
            :label="'option_value'"
            @change="changeDataInputType($event, attribute.attribute_code)"
          ></s-select>
        </template>

        <template
          v-if="attribute.data_type.id == isSelectFind && attribute.attribute_code != 'contact_user'"
        >
          <s-select-search
            :data-vv-scope="scope"
            v-model.number="attribute.attribute_value"
            v-validate="{ required: attribute.is_required ? true : false }"
            :id="attribute.attribute_code"
            :name="attribute.attribute_code"
            :data="attribute.attribute_options"
            :label="'option_value'"
          ></s-select-search>
        </template>

        <template
          v-if="attribute.data_type.id == isSelectFind && attribute.attribute_code == 'contact_user'"
        >
          <!--&lt;!&ndash;customerContactSortDelete&ndash;&gt;customerContacts-->
          <s-select-search
            :data-vv-scope="scope"
            v-model.number="contact_select"
            v-validate="{ required: attribute.is_required ? true : false }"
            :id="attribute.attribute_code"
            :name="attribute.attribute_code"
            :data="customerContactSortDelete"
            :label="'full_name'"
            @input="changeContact"
          ></s-select-search>
        </template>

        <template v-if="attribute.data_type.id == isMultipleSelect">
          <s-select-multiple
            :data-vv-scope="scope"
            v-model="attribute.attribute_value"
            v-validate="{ required: attribute.is_required ? true : false }"
            :id="attribute.attribute_code"
            :name="attribute.attribute_code"
            :data="attribute.attribute_options"
            :label="'option_value'"
          ></s-select-multiple>
        </template>

        <template v-if="attribute.data_type.id == isTag">
          <!--@Todo Sau này làm component tags-->
          <s-tags
            :data-vv-scope="scope"
            v-model="attribute.attribute_value"
            v-validate="{ required: attribute.is_required ? true : false }"
            :id="attribute.attribute_code"
            :name="attribute.attribute_code"
            :data="attribute.attribute_options"
            :label="'option_value'"
          ></s-tags>
        </template>

        <template v-if="attribute.data_type.id == isTextArea">
          <s-textarea
            :data-vv-scope="scope"
            style="resize:vertical; max-height: 120px; min-height:40px"
            v-model="attribute.attribute_value"
            v-validate="{ required: attribute.is_required ? true : false, max : 1025 }"
            :id="attribute.attribute_code"
            :name="attribute.attribute_code"
          ></s-textarea>
        </template>

        <template v-if="attribute.data_type.id == isCheckboxMultiple">
          <div
            class="nt-list-checkbox"
            v-for="(option, indexA) in attribute.attribute_options"
            :key="indexA"
          >
            <label class="nt-checkbox nt-checkbox-primary">
              <input
                :data-vv-scope="scope"
                type="checkbox"
                :value="option.id"
                v-model="attribute.attribute_value"
                v-validate="{ required: attribute.is_required ? true : false }"
                :name="attribute.attribute_code"
              />
              <!--nt-checkbox-text-->
              <span
                class
                style="width: 100%; word-break: break-all; font-size:13px !important;"
              >{{ option['option_value'] }}</span>
              <span class="nt-checkbox-symbol"></span>
            </label>
          </div>
        </template>

        <template v-if="attribute.data_type.id == isRadio">
          <s-radio-multiple
            :data-vv-scope="scope"
            :col="'col-md-6'"
            v-model="attribute.attribute_value"
            :label="'option_value'"
            v-validate="{ required: attribute.is_required ? true : false }"
            :id="attribute.attribute_code"
            :name="attribute.attribute_code"
            :data="attribute.attribute_options"
          ></s-radio-multiple>
        </template>

        <template v-if="attribute.data_type.id == isUser">
          <v-select
            v-model="attribute.attribute_value"
            label="full_name"
            :options="listUsers"
            index="id"
            :id="attribute.attribute_code"
            :name="attribute.attribute_code"
            :data-vv-scope="scope"
            v-validate="{ required: attribute.is_required ? true : false }"
            @change="changeDataInputType(attribute.attribute_code)"
          >
            <template slot="option" slot-scope="option">
              <b>{{ option.full_name | truncateWords }}</b>
              <br />
              {{ option.email | truncateWords }}
            </template>
          </v-select>
        </template>

        <template v-if="attribute.data_type.id == isUserMultiple">
          <v-select
            v-model="attribute.attribute_value"
            label="full_name"
            :options="listUsers"
            index="id"
            multiple
            :id="attribute.attribute_code"
            :name="attribute.attribute_code"
            :data-vv-scope="scope"
            v-validate="{ required: attribute.is_required ? true : false }"
            @change="changeDataInputType(attribute.attribute_code)"
          >
            <template slot="option" slot-scope="option">
              <b>{{ option.full_name | truncateWords }}</b>
              <br />
              {{ option.email | truncateWords }}
            </template>
          </v-select>
        </template>

        <template v-if="attribute.data_type.id == 'charge_person' && extend">
          <v-select
            v-model="deal.assigners"
            label="full_name"
            :options="listUsers"
            index="id"
            multiple
            id="assigners"
            name="assigners"
          >
            <template slot="option" slot-scope="option">
              <b>{{ option.full_name | truncateWords }}</b>
              <br />
              {{ option.email | truncateWords }}
            </template>
          </v-select>
        </template>
      </template>

      <div
        class="form-control-feedback m--font-danger"
        v-if="server_errors != '' && server_errors[attribute.attribute_code]"
      >
        <template
          v-if="server_errors[attribute.attribute_code].exist || server_errors[attribute.attribute_code][0] === 'exist'"
        >{{ attribute.attribute_name }} bị trùng.</template>
        <template
          v-else-if="server_errors[attribute.attribute_code].not_exist || server_errors[attribute.attribute_code][0] === 'not_exist'"
        >{{ attribute.attribute_name }} đã bị xóa, vui lòng tải lại trang.</template>
        <template v-else>{{ server_errors[attribute.attribute_code][0] }}</template>
      </div>

      <div
        class="form-control-feedback m--font-danger"
        v-else-if="errors.has(scope + '.' + attribute.attribute_code) && attribute.data_type_id !== 13"
      >
        <div v-for="(error, indexB) in errors.items" :key="indexB">
          <template v-if="errors.items.length > 0">
            <template
              v-if="attribute.attribute_code == error.field && error.rule == 'required'"
            >Không được để trống trường này.</template>

            <template v-if="attribute.attribute_code == error.field && error.rule == 'max'">
              Giới hạn
              <template v-if="attribute.data_type_id === 12">1025</template>
              <template v-else>250</template> ký tự.
            </template>

            <template v-if="attribute.attribute_code == error.field && error.rule == 'regex'">
              Định dạng
              <span class="text-lowercase">{{ attribute.attribute_name }}</span> không đúng.
            </template>
          </template>
        </div>
      </div>

      <div
        class="form-control-feedback m--font-danger"
        v-else-if="errors.has(scope + '.' + attribute.attribute_code) && attribute.data_type_id === 13"
      >Không được để trống trường này</div>

      <div class="form-control-feedback m--font-danger" v-else>&nbsp;</div>
    </div>
  </div>
</template>
